unit Config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, Menus, ShellAPI, IniFiles, 
  About {o[WtH[} ;

const
  NOTIFYICON_MSG = WM_USER + 1; // ^XNgCACR̃bZ[W
	NOTIFYICON_TEXT = 'Wipman';   // ^XNgCACRToolTipText
  HKM_GETHOTKEY = WM_USER + 2;  // zbgL[Rg[ւ̃bZ[W
  HOTKEYF_SHIFT = $01;          // ShiftL[
  HOTKEYF_CONTROL = $02;        // ControlL[
  HOTKEYF_ALT = $04;            // AltL[
type
  TWipmanForm = class(TForm)
    PopupMenu1: TPopupMenu;
      MiShowForm: TMenuItem;
      MiAbout: TMenuItem;
      MiLine1: TMenuItem;
      MiExit: TMenuItem;
    GroupBox1: TGroupBox;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      Label4: TLabel;
      Label5: TLabel;
      HotKey1: THotKey;
      HotKey2: THotKey;
      HotKey3: THotKey;
      HotKey4: THotKey;
      HotKey5: THotKey;
    BitBtn1: TBitBtn;
    // ^XNgCɃACRǉ葱
    procedure SetNotifyIcon();
    // ^XNgC̃ACR폜葱
    procedure DeleteNotifyIcon();
    // zbgL[o^葱
    procedure RegisterHotKeys();
    // zbgL[̓o^葱
    procedure UnRegisterHotKeys();
    // ^XNgC̃ACR̃bZ[W葱
    procedure MessageNotifyIcon(var Msg : TMsg); message NOTIFYICON_MSG;
    // zbgL[bZ[W葱
    procedure MessageHotKey(var Msg : TWMHotKey); message WM_HOTKEY;
    // tH[쐬
    procedure FormCreate(Sender: TObject);
    // tH[p
    procedure FormDestroy(Sender: TObject);
    // ݒʕ\
    procedure MiShowFormClick(Sender: TObject);
    // o[W
    procedure MiAboutClick(Sender: TObject);
    // I
    procedure MiExitClick(Sender: TObject);
    // OK {^
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;


const
  Ver = 'Ver 1.00';   // AvP[Vo[W̒`
var
  WipmanForm: TWipmanForm;     // ݒʃtH[
	NotifyIcon: TNotifyIconData; // ^XNgCACR̍\
  AppPath : string;            // AvP[VpX

implementation

{$R *.dfm}

// tH[̍쐬
procedure TWipmanForm.FormCreate(Sender: TObject);
var
  Ini: TIniFile;
  i: Integer;        // JE^
  NotFirst: Boolean; // Nǂ
  tmpHotKey:THotKey; // zbgL[Rg[
begin
  // AvP[VpX̎擾
  AppPath := ExtractFilePath(Application.ExeName);
  // ini t@C̎擾
  Ini := TIniFile.Create(AppPath+'Wipman.ini');
    NotFirst := Ini.ReadBool('Wipman', 'NotFirst', False); // Nǂ
    // Qڈȍ~Ȃ
    if NotFirst then begin
      for i:=0 to 4 do begin 
        tmpHotKey := THotKey(FindComponent('HotKey'+IntToStr(i+1)));
        tmpHotKey.HotKey :=
          TextToShortCut(Ini.ReadString('Wipman','HotKey'+IntToStr(i+1),''));
      end;
      RegisterHotKeys;
    end;
  Ini.Free;
  // EChE^Cgݒ
  Caption := Application.Title + Ver;
  // ^XNgCACR̓o^
  SetNotifyIcon;
  // NȂ
  if (not NotFirst) then ShowModal;
end;

// tH[̔j
procedure TWipmanForm.FormDestroy(Sender: TObject);
var
  i:Integer;         // JE^
  Ini:TIniFile;      // IniFile
  tmpHotKey:THotKey; // zbgL[Rg[
begin
  // Init@Cɏ
  Ini := TIniFile.Create(AppPath+'Wipman.ini');
    Ini.WriteString('Wipman','Ver', Ver);
    Ini.WriteBool('Wipman','NotFirst', True);
    for i:=0 to 4 do begin
      tmpHotKey := THotKey(FindComponent('HotKey'+IntToStr(i+1)));
      Ini.WriteString('Wipman','HotKey'+IntToStr(i+1),ShortCutToText(tmpHotKey.HotKey));
    end;
  Ini.Free;
  // ^XNgCACR̔j
  DeleteNotifyIcon
end;

// |bvAbv - ݒ
procedure TWipmanForm.MiShowFormClick(Sender: TObject); begin
  // ݒʂ̂Ƃ͓o^ς݃zbgL[
  UnregisterHotKeys;
  // ݒʂ̕\
  WipmanForm.ShowModal;
end;

// |bvAbv - o[W
procedure TWipmanForm.MiAboutClick(Sender: TObject); begin
  // o[WtH[\
  AboutForm.ShowModal;
end;

// |bvAbv - I
procedure TWipmanForm.MiExitClick(Sender: TObject); begin
  // I͓o^ς݃zbgL[폜
  UnRegisterHotKeys;
  // IbZ[W𑗐M
  PostQuitMessage(0);
end;

// OK{^
procedure TWipmanForm.BitBtn1Click(Sender: TObject); begin
  // zbgL[o^
  RegisterHotKeys;
end;

// zbgL[̓o^
procedure TWipmanForm.RegisterHotKeys();
var
  i: Integer;                     // JE^
  tmpHotKey: THotKey;             // zbgL[Rg[
  wHotKey: WORD;                  // zbgL[擾
  uMod,uModifiers,uVirtual: UINT; // L[EzL[擾
begin
  for i:=0 to 4 do begin
    // R|[lg擾
    tmpHotKey := THotKey(FindComponent('HotKey'+IntToStr(i+1)));
    // zbgL[ݒ肳ĂȂȂ珈Ȃ
    if tmpHotKey.HotKey = TextToShortCut('') then continue;
    // zbgL[擾
    wHotKey := WORD(SendMessage(tmpHotKey.Handle, HKM_GETHOTKEY, 0, 0));
    // L[̎擾
    uModifiers := UINT(HIBYTE(wHotKey));
    // zL[R[h̎擾
    uVirtual := UINT(LOBYTE(wHotKey));
    // L[̕ϊ
    uMod := 0;
    if (uModifiers and HOTKEYF_ALT = HOTKEYF_ALT) then uMod := uMod + MOD_ALT;
    if (uModifiers and HOTKEYF_CONTROL = HOTKEYF_CONTROL) then uMod := uMod + MOD_CONTROL;
    if (uModifiers and HOTKEYF_SHIFT = HOTKEYF_SHIFT) then uMod := uMod + MOD_SHIFT;
    // zbgL[Windowsɓo^
    RegisterHotKey(Handle, i, uMod, uVirtual);
  end;
end;

// zbgL[̉
procedure TWipmanForm.UnRegisterHotKeys();
var
  i: Integer;
begin
  for i:=0 to 4 do begin
    UnregisterHotKey(Handle, i); // o^ς݃zbgL[
  end;
end;

// zbgL[̃bZ[W
procedure TWipmanForm.MessageHotKey(var Msg : TWMHotKey);
var
  hWindow: HWND; // Winamp̃EBhEnh擾
  vKey: WPARAM;  // WinampɑL[R[h
begin
  // Winamp2̃EBhEnh̎擾
  hWindow := FindWindow('Winamp v1.x', nil);
  // Winamp3̃EBhEnh擾
  if (hWindow = 0) then begin
    hWindow := FindWindow('BaseWindow_RootWnd', 'normal');
  end;
  // ł߂Ȃ葱I
  if (hWindow = 0) then begin
    Exit;
  end;
  // 
  case Msg.HotKey of
    0: vKey := Ord('Z'); { ŐȂ }
    1: vKey := Ord('X'); { t }
    2: vKey := Ord('C'); { ꎞ~ }
    3: vKey := Ord('V'); { ~ }
    4: vKey := Ord('B'); { ̋Ȃ }
    else vKey := 0;
  end;
  // WinampɑM
  SendMessage(hWindow, WM_KEYDOWN, vKey, 0);
end;

// ^XNgCɃACRǉ
procedure TWipmanForm.SetNotifyIcon(); begin
	NotifyIcon.cbSize	:= sizeof( NotifyIcon );
 	NotifyIcon.uID		:= 1;
 	NotifyIcon.Wnd 		:= Handle;
 	NotifyIcon.uFlags	:= NIF_MESSAGE or NIF_ICON or NIF_TIP ;
 	NotifyIcon.uCallbackMessage := NOTIFYICON_MSG;
 	NotifyIcon.hIcon 	:= Application.Icon.Handle;
  NotifyIcon.szTip  := NOTIFYICON_TEXT;
  Shell_NotifyIcon( NIM_ADD ,@NotifyIcon );
end;

// ^XNgC̃ACR폜
procedure TWipmanForm.DeleteNotifyIcon(); begin
  Shell_NotifyIcon(NIM_DELETE, @NotifyIcon);
end;

// ^XNgCACR̃bZ[W
procedure TWipmanForm.MessageNotifyIcon(var Msg: TMsg);
var
  Pos : TPoint;
begin
  GetCursorPos(Pos);
  if  (Msg.wParam = WM_RBUTTONDOWN) then begin
    // |bvAbvj[̕\
    PopupMenu1.Popup(Pos.X,Pos.Y);
  end;
end;

end.
